EM.Presentation/Controllers/CommentController.cs
using EM.Data;
using EM.Domain.Entities;
using EM.Presentation.Areas.Tenant;
using EM.Presentation.Areas.Tenant.Helpers;
using EM.Presentation.Models;
using EM.Service;
using EM.Service.UserService;
using Microsoft.AspNet.Identity;
using Microsoft.AspNet.Identity.Owin;
using Microsoft.Owin.Security;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Security;

namespace EM.Presentation.Controllers
{
    public class CommentController : AppController
    {

        IUserService UserService;
        private ApplicationUserManager _userManager;
        private ApplicationRoleManager _roleManager;
        private Tenant _tenant;
        IParticipantService MyParticipantService;
        ICommentService MyCommentService;
        IReplyService MyReplyService;

        public CommentController()
        {
            UserService = new UserService();
            MyParticipantService = new ParticipantService();
            MyCommentService = new CommentService();
            MyReplyService = new ReplyService();
        }
        public CommentController(ApplicationUserManager userManager, ApplicationRoleManager roleManager):base()
        {
            UserManager = userManager;
            RoleManager = roleManager;
        }

        public Tenant Current_Tenant
        {
            get
            {
                return _tenant ?? base.current_tenant;
            }
            private set
            {
                _tenant = value;
            }
        }
        public ApplicationUserManager UserManager
        {
            get
            {
                return _userManager ?? HttpContext.GetOwinContext().GetUserManager<ApplicationUserManager>();
            }
            private set
            {
                _userManager = value;
            }
        }

        public IAuthenticationManager AuthenticationManager
        {
            get
            {
                return HttpContext.GetOwinContext().Authentication;
            }
        }

        public ApplicationRoleManager RoleManager
        {
            get
            {
                return _roleManager ?? Request.GetOwinContext().GetUserManager<ApplicationRoleManager>();
            }
            private set
            {
                _roleManager = value;
            }
        }


        /************************************ Actions ************************************************************/


        
        // GET: Comment
        //Affichage
        public ActionResult Index(string searchString)
        {
            var Comments = new List<CommentVM>();
            ApplicationUser current_user = UserManager.FindById(System.Web.HttpContext.Current.User.Identity.GetUserId());
            foreach (Comment c in MyCommentService.SearchCommentsByName(searchString))
            {
                var participant = UserManager.FindById(c.ParticipantId);
                Comments.Add(new CommentVM()
                {
                    Id = c.Id,
                    Text = c.Text,
                    CreatedOn = c.CreatedOn,
                    //ParticipantId = c.ParticipantId,
                    ParticipantName = participant.UserName,
                    ParticipantImage = participant.ParticipantImage,
                });
            }
            return View(Comments);
        }

        // GET: Comment/Details/5
        public ActionResult Details(int id)
        {
            return View();
        }

        // GET: Comment/Create
        public ActionResult Create()
        {
            return View();
        }

        // POST: Comment/Create
        [HttpPost]
        [TenantAuthorize(Roles = "Participant")]
        public PartialViewResult Create(string contenu)
        {
            ApplicationUser current_user = UserManager.FindById(System.Web.HttpContext.Current.User.Identity.GetUserId());
            Comment CommentDoamin = new Comment()
            {

                Text = contenu,
                CreatedOn = DateTime.UtcNow,
                ParticipantId = current_user.Id,
                ParticipantName = current_user.UserName,
                //ParticipantImage = ParticipantImage.FileName,
                
            };
            MyCommentService.Add(CommentDoamin);
            MyCommentService.Commit();
 


            return PartialView("OneComment",new CommentVM{Text= CommentDoamin.Text,
                CreatedOn= CommentDoamin.CreatedOn,
                ParticipantId= CommentDoamin.ParticipantId,
                ParticipantName=CommentDoamin.ParticipantName,
                ParticipantImage=CommentDoamin.ParticipantImage,
            });
        }

        // GET: Comment/Edit/5
        public ActionResult Edit(int id)
        {
            return View();
        }

        // POST: Comment/Edit/5
        [HttpPost]
        public ActionResult Edit(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add update logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: Comment/Delete/5
        public ActionResult Delete(int id)
        {
            return View();
        }

        // POST: Comment/Delete/5
        [HttpPost]
        public ActionResult Delete(int id, FormCollection collection)
        {
            Comment c = MyCommentService.GetById(id);
            MyCommentService.Delete(c);
            MyCommentService.Commit();
                

                return RedirectToAction("Index");
           
        }



        public ActionResult Edit2(int id)
        {

            Comment p = MyCommentService.GetById(id);
            CommentVM pm = new CommentVM();

            pm.ParticipantId = p.ParticipantId;
            pm.Text = p.Text;
            pm.CreatedOn = p.CreatedOn;
            return View(pm);
        }

        // POST: Resource/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit2(int id, CommentVM pm)
        {

            try
            {

                Comment p = MyCommentService.GetById(id);

                p.ParticipantId = pm.ParticipantId;
                p.Text = pm.Text;
                p.CreatedOn = pm.CreatedOn;
                MyCommentService.Update(p);
                MyCommentService.Commit();


                // TODO: Add update logic here




                return RedirectToAction("Index");
            }
            catch (Exception ex)
            {
                return View(pm);
            }
        }


        ///////////******************************************REPLY************************************************/////////////////////////////////
        // GET: Reply
        public ActionResult Index1(int commid)
        {
            var replies = new List<ReplyVM>();
            ApplicationUser current_user = UserManager.FindById(System.Web.HttpContext.Current.User.Identity.GetUserId());
            foreach (Reply r in MyReplyService.GetMany())
            {
                if (r.CommentId == commid)
                {
                    var participant = UserManager.FindById(r.ParticipantId);
                    replies.Add(new ReplyVM()
                    {
                        Id = r.Id,
                        Text = r.Text,
                        CreatedOn = r.CreatedOn,
                        ParticipantId = r.ParticipantId,
                        ParticipantName = r.ParticipantName,
                        CommentId = r.CommentId,

                    });
                    //ViewBag.commentId = commid;
                }
            }
            return View(replies);
        }


        // POST: Reply/Create
        [HttpPost]
        [TenantAuthorize(Roles = "Participant")]
        public PartialViewResult Create1(string contenu1)
        {
            ApplicationUser current_user = UserManager.FindById(System.Web.HttpContext.Current.User.Identity.GetUserId());
            Reply RepliesDomain = new Reply()
            {

                Text = contenu1,
                CreatedOn = DateTime.UtcNow,
                ParticipantId = current_user.Id,
                ParticipantName = current_user.UserName,

            };
            MyReplyService.Add(RepliesDomain);
            MyReplyService.Commit();


            return PartialView("OneReply", new ReplyVM
            {
                Text = RepliesDomain.Text,
                CreatedOn = RepliesDomain.CreatedOn,
                ParticipantId = RepliesDomain.ParticipantId,
                ParticipantName = RepliesDomain.ParticipantName,
            });
        }



        // POST: Reply/Delete/5
        [HttpPost]
        public ActionResult Delete1(int id, FormCollection collection)
        {
            Reply r = MyReplyService.GetById(id);
            MyReplyService.Delete(r);
            MyReplyService.Commit();


            return RedirectToAction("Index");
        }


        public ActionResult Edit3(int id)
        {

            Reply r = MyReplyService.GetById(id);
            ReplyVM rm = new ReplyVM();

            rm.ParticipantId = r.ParticipantId;
            rm.Text = r.Text;
            rm.CreatedOn = r.CreatedOn;
            return View(rm);
        }

        // POST: Resource/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit3(int id, ReplyVM rm)
        {

            try
            {

                Reply r = MyReplyService.GetById(id);

                r.ParticipantId = rm.ParticipantId;
                r.Text = rm.Text;
                r.CreatedOn = rm.CreatedOn;
                MyReplyService.Update(r);
                MyReplyService.Commit();


                // TODO: Add update logic here




                return RedirectToAction("Index1");
            }
            catch (Exception ex)
            {

EM.Presentation/Controllers/EventController.cs
using EM.Data;
using EM.Domain.Entities;
using EM.Presentation.Areas.Tenant;
using EM.Presentation.Models;
using EM.Service;
using EM.Service.UserService;
using Microsoft.AspNet.Identity;
using Microsoft.AspNet.Identity.Owin;
using Microsoft.Owin.Security;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;

namespace EM.Presentation.Controllers
{
    public class EventController : AppController
    {
        IUserService UserService;
        private ApplicationUserManager _userManager;
        private ApplicationRoleManager _roleManager;
        private EM.Domain.Entities.Tenant _tenant;
        ICommentService MyCommentService;

        Evenement_service aa = new Evenement_service();
        public EventController()
        {
            UserService = new UserService();
            MyCommentService = new CommentService();
        }
        public EventController(ApplicationUserManager userManager, ApplicationRoleManager roleManager):base()
        {
            UserManager = userManager;
            RoleManager = roleManager;
        }

        public EM.Domain.Entities.Tenant Current_Tenant
        {
            get
            {
                return _tenant ?? base.current_tenant;
            }
            private set
            {
                _tenant = value;
            }
        }
        public ApplicationUserManager UserManager
        {
            get
            {
                return _userManager ?? HttpContext.GetOwinContext().GetUserManager<ApplicationUserManager>();
            }
            private set
            {
                _userManager = value;
            }
        }

        public IAuthenticationManager AuthenticationManager
        {
            get
            {
                return HttpContext.GetOwinContext().Authentication;
            }
        }

        public ApplicationRoleManager RoleManager
        {
            get
            {
                return _roleManager ?? Request.GetOwinContext().GetUserManager<ApplicationRoleManager>();
            }
            private set
            {
                _roleManager = value;
            }
        }



        // GET: Tenant/Evenement
        public ActionResult Home()
        {
            return View();
        }
        public ActionResult Index()
        {

            
            var events = aa.GetMany(null, null, t => t.Tenant);
            
                return View(events);
            
        }

        // GET: EventBack/Details/5
        public ActionResult Details(int id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Evenement conge = aa.GetById(id);
            if (conge == null)
            {
                return HttpNotFound();
            }

            var Comments = new List<CommentVM>();
            ApplicationUser current_user = UserManager.FindById(System.Web.HttpContext.Current.User.Identity.GetUserId());
            foreach (Comment c in MyCommentService.GetMany(c => c.EventId == conge.EventId))
            {
                var participant = UserManager.FindById(c.ParticipantId);
                Comments.Add(new CommentVM()
                {
                    Id = c.Id,
                    Text = c.Text,
                    CreatedOn = c.CreatedOn,
                    ParticipantId = c.ParticipantId

                });
                ViewData["comments"] = Comments;                
            }
            return View(conge);
        }

        [HttpPost]
        public ActionResult Details(int? id, string contenu)
        {
            if (!id.HasValue)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Evenement conge = aa.GetById(id.GetValueOrDefault());
            if (conge == null)
            {
                return HttpNotFound();
            }

            var Comments = new List<CommentVM>();
            ApplicationUser current_user = UserManager.FindById(System.Web.HttpContext.Current.User.Identity.GetUserId());
            foreach (Comment c in MyCommentService.GetMany(c => c.EventId == conge.EventId))
            {
                var participant = UserManager.FindById(c.ParticipantId);
                Comments.Add(new CommentVM()
                {
                    Id = c.Id,
                    Text = c.Text,
                    CreatedOn = c.CreatedOn,
                    ParticipantId = c.ParticipantId

                });
                ViewData["comments"] = Comments;
            }

            //Comment creation
            if (contenu != null)
            {

                Comment CommentDoamin = new Comment()
                {

                    Text = contenu,
                    CreatedOn = DateTime.UtcNow,
                    ParticipantId = current_user.Id,
                    ParticipantName = current_user.UserName,
                    EventId = conge.EventId
                    //ParticipantImage = ParticipantImage.FileName,

                };
                MyCommentService.Add(CommentDoamin);
                MyCommentService.Commit();



                return PartialView("~/Views/Comment/OneComment.cshtml", new CommentVM
                {
                    Text = CommentDoamin.Text,
                    CreatedOn = CommentDoamin.CreatedOn,
                    ParticipantId = CommentDoamin.ParticipantId,
                    ParticipantName = CommentDoamin.ParticipantName,
                    ParticipantImage = CommentDoamin.ParticipantImage,
                });

            }
            return View(conge);
        }

        // GET: EventBack/Create
        public ActionResult Create()
        {
            return View();
        }

        // POST: EventBack/Create
        [HttpPost]
        public ActionResult Create(FormCollection collection)
        {
            try
            {
                // TODO: Add insert logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: EventBack/Edit/5
        public ActionResult Edit(int id)
        {
            return View();
        }

        // POST: EventBack/Edit/5
        [HttpPost]
        public ActionResult Edit(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add update logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        // GET: EventBack/Delete/5
        public ActionResult Delete(int id)
        {
            return View();
        }

        // POST: EventBack/Delete/5
        [HttpPost]
        public ActionResult Delete(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add delete logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }
    }
}

EM.Presentation/Views/Event/Details.cshtml
@using EM.Domain.Entities
@using System.Collections.Generic;
@model Evenement
@{string path = "~/Content/Upload/" + @Model.Picture;}

@{
    ViewBag.Title = "Index";
    Layout = "~/Views/Shared/_CustomLayout.cshtml";
    var comments = ViewData["comments"] as IEnumerable<EM.Presentation.Models.CommentVM>;
}
<!DOCTYPE html>

<html>
<head>
    <meta name="viewport" content="width=device-width" />
    <title>Events</title>
    <!--   -->
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
    <script>
        $(document).ready(function () {
            $("button").click(function () {
                $("textarea").toggle();
            });
        });
    </script>
</head>
<body>



    <h3>Event</h3>
    <center>

        <div>

            <img alt="Evenement" src="@Url.Content(path)" width="220" height="170" />

        </div>

        <div class="card-body">

            <dt>
                @Html.DisplayNameFor(model => model.Name)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.Name)
            </dd>

            <dt>
                @Html.DisplayNameFor(model => model.Theme)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.Theme)
            </dd>

            <dt>
                @Html.DisplayNameFor(model => model.Location)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.Location)
            </dd>

            <dt>
                @Html.DisplayNameFor(model => model.StartDate)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.StartDate)
            </dd>

            <dt>
                @Html.DisplayNameFor(model => model.EndDate)
            </dt>

            <dd>
                @Html.DisplayFor(model => model.EndDate)
            </dd>

            </dl>

            <a class="btn btn-primary btn-round" href="@Url.Action("Index")"> Back to List </a>



        </div>


        <!-- your part starts here ---->
        @if (comments != null)
        {

            @(Html.BeginForm())
            {
                <div>
                    <nav class="navbar navbar-expand-lg bg-rose">
                        <div class="container">

                            <div class="collapse navbar-collapse">

                                <form class="form-inline ml-auto">
                                    @Html.TextBox("searchString")
                                    <button type="submit" class="btn btn-white btn-raised btn-fab btn-round" id="submit">
                                        <i class="material-icons">search </i>
                                    </button>
                                </form>
                            </div>
                        </div>
                    </nav>
                    
                </div>

            }
            <table class="table text-center" id="table" align="center">
                <tr style="border:1px solid black"></tr>

                @foreach (var item in comments)
                {
                    <tr>
                        <td>

                            @Html.Partial("~/Views/Comment/_DisplayImg.cshtml", item)
                        </td>

                        <td>
                            @Html.DisplayFor(modelItem => item.ParticipantName)
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => item.Text)
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => item.CreatedOn)
                        </td>
                        <td>
                            <span class="likebtn-wrapper" data-theme="custom" data-icon_l_c_v="#fb0505" data-icon_d_c_v="#f0ff00" data-label_c_v="#ff0000" data-counter_d_c="#f0ff00" data-lang="fr" data-ef_voting="buzz" data-identifier="dis/like" data-voting_frequency="90"></span>
                        </td>


                        <td>

                            @Html.ActionLink("Rep", "Index1", "Comment", new { commid = item.Id }) ( @Html.Action("nbReplies", "Comment", new { idCom = item.Id }) ) |
                            @Html.ActionLink("Edit", "Edit2", "Comment", new { id = item.Id }) |
                            @*<a href="@Url.Action("Delete", "Comment", new { id=item.Id })" class="button" style="font-size:24px"> <i class="fa fa-trash-o"></i></a>*@
                            @Html.ActionLink("Delete", "Delete", "Comment", new { id = item.Id })
                        </td>
                    </tr>
                }
            </table>
        }



        <table>
            <tr>
                <td>
                    <textarea id="comm" placeholder="votre commentaire"></textarea>
                </td>
                <td>
                    <button class="btn btn-rose" id="show">Mettre un commentaire&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i style='font-size:24px' class='far'>&#xf075;</i><div class="ripple-container"></div></button>
                </td>
            </tr>
        </table>


        @section scripts{
            <!-- LikeBtn.com BEGIN -->

            <script>(function (d, e, s) { if (d.getElementById("likebtn_wjs")) return; a = d.createElement(e); m = d.getElementsByTagName(e)[0]; a.async = 1; a.id = "likebtn_wjs"; a.src = s; m.parentNode.insertBefore(a, m) })(document, "script", "//w.likebtn.com/js/w/widget.js");</script><!-- LikeBtn.com END -->

            <script>
    $(function() {
        function getContent(){
            return document.getElementById("comm").value
        }

        $("#comm").keyup(function (e){
            var keycode = (event.keyCode ? event.keyCode : event.which);
            if(keycode == '13'){

                var contenu = document.getElementById("comm").value;
                if (contenu == "") {
                    window.console("un commentaire  ne peut pas etre vide ");
                }
                else {

                    $.ajax({
                        url: '@Url.Action("Details", "Event")' + "?contenu=" + contenu,
                        type: "POST",
                        success: function (result) {
                            $('#table').append(result)
                            $("#comm").val("")
                        }

                    })

                }
            }


        })
    });
            </script>

        }

</body>
</html>

EM.Presentation/Views/Event/Index.cshtml
@model IEnumerable<EM.Domain.Entities.Evenement>
@{
    ViewBag.Title = "Index";
    Layout = "~/Views/Shared/_CustomLayout.cshtml";
}

<!DOCTYPE html>

<html>
<head>
    <meta name="viewport" content="width=device-width" />
    <title>Events</title>
</head>
<body border="2">
    
    <table class="table">
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.Name)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Picture)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Theme)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Location)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.StartDate)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.EndDate)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Tenant)
            </th>
            <th></th>
        </tr>
    
    @foreach (var item in Model) {
        <tr>
            <td>
                @Html.DisplayFor(modelItem => item.Name)
            </td>
            <td>
                @{
                    string path = "~/Content/Upload/" + @item.Picture;
                }
                <img src="@Url.Content(path)" width="80" height="80" />
            </td>

            <td>
                @Html.DisplayFor(modelItem => item.Theme)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Location)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.StartDate)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.EndDate)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Tenant.TenantName)
            </td>
            <td>
               
                @Html.ActionLink("Details", "Details", new { id = item.EventId })
            
            </td>
        </tr>
    }
    
    </table>
</body>
</html>